﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Wisej.Core;
using Wisej.Web;

namespace Wisej.Clipboard
{
	public class MyDataGrid : DataGridView
	{
		ComponentTool copyTool = null;

		public MyDataGrid()
		{
			this.copyTool = this.Tools.Add("copy", "icon-copy");
			this.copyTool.Enabled = false;
		}

		protected override bool ProcessDialogKey(Keys keyData)
		{
			bool handled = base.ProcessDialogKey(keyData);

			if (keyData == (Keys.Control | Keys.C) || keyData == (Keys.Control | Keys.Insert))
			{
				if (Wisej.Web.Clipboard.ContainsText())
				{
					Wisej.Web.Clipboard.SetClientText(Wisej.Web.Clipboard.GetText(TextDataFormat.Html));
					this.copyTool.Enabled = true;

					AlertBox.Show("Click the copy tool button to transfer the HTML text to the browser's clipboard.", icon: MessageBoxIcon.Information);
				}
			}

			return handled;
		}

		protected override void OnWebRender(dynamic config)
		{
			base.OnWebRender((object)config);

			IWisejComponent me = this;
			if (me.IsNew)
			{
				// copy to the browser's clipboard when clicking the copy tool button.
				Eval(String.Format(@"
					this.addListener(""toolClick"", function(e){{

						var id = ""{0}"";
						if (e.getData() == id)
							Wisej.Core.copy();
					}});
				", ((IWisejComponent)this.copyTool).Id));
			}
		}
	}
}